diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/ImprovedNoise.java b/game/core/src/main/java/net/minecraft/core/world/noise/ImprovedNoise.java
index 036048bef..a2f3d8542 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/ImprovedNoise.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/ImprovedNoise.java
@@ -1,162 +1,220 @@
 package net.minecraft.core.world.noise;
 
+import org.jetbrains.annotations.NotNull;
+
 import java.util.Random;
 
 public class ImprovedNoise
-    extends BaseImprovedNoise
-{
-    public ImprovedNoise(Random random)
-    {
+    extends BaseImprovedNoise {
+    private final @NotNull LegacyNoiseType legacyNoiseType;
+
+    public ImprovedNoise(final @NotNull Random random, final @NotNull LegacyNoiseType legacyNoiseType) {
         super(random);
+
+        this.legacyNoiseType = legacyNoiseType;
+    }
+
+    public ImprovedNoise(final @NotNull Random random) {
+        this(random, LegacyNoiseType.NONE);
     }
 
     @Override
-    public void add(double[] densityArray, double x, double y, double z,
-                    int xSize, int ySize, int zSize, double xScale, double yScale,
-                    double zScale, double levelScale)
-    {
-        if(ySize == 1)
-        {
-            int j3 = 0;
-            double d12 = 1.0D / levelScale;
-            for(int i4 = 0; i4 < xSize; i4++)
-            {
-                double d14 = (x + (double)i4) * xScale + xo;
-                int j4 = (int)d14;
-                if(d14 < (double)j4)
-                {
-                    j4--;
-                }
-                int k4 = j4 & 0xff;
-                d14 -= j4;
-                double d17 = d14 * d14 * d14 * (d14 * (d14 * 6D - 15D) + 10D);
-                for(int l4 = 0; l4 < zSize; l4++)
-                {
-                    double d19 = (z + (double)l4) * zScale + zo;
-                    int j5 = (int)d19;
-                    if(d19 < (double)j5)
-                    {
-                        j5--;
-                    }
-                    int l5 = j5 & 0xff;
-                    d19 -= j5;
-                    double d21 = d19 * d19 * d19 * (d19 * (d19 * 6D - 15D) + 10D);
-                    int l = p[k4] + 0;
-                    int j1 = p[l] + l5;
-                    int k1 = p[k4 + 1] + 0;
-                    int l1 = p[k1] + l5;
-                    double d9 = lerp(d17, grad(p[j1], d14, d19), grad(p[l1], d14 - 1.0D, 0.0D, d19));
-                    double d11 = lerp(d17, grad(p[j1 + 1], d14, 0.0D, d19 - 1.0D), grad(p[l1 + 1], d14 - 1.0D, 0.0D, d19 - 1.0D));
-                    double d23 = lerp(d21, d9, d11);
-                    densityArray[j3++] += d23 * d12;
-                }
+    public void add(
+        final double @NotNull [] out,
+        final double x, final double y, final double z,
+        final int xSize, final int ySize, final int zSize,
+        final double xScale, final double yScale, final double zScale,
+        final double valueScale
+    ) {
+        final double scale = 1.0 / valueScale;
 
-            }
-            return;
-        }
-        if(zSize == 1)
-        {
-            int j3 = 0;
-            double d12 = 1.0D / levelScale;
-            for(int i4 = 0; i4 < xSize; i4++)
-            {
-                double d14 = (x + (double)i4) * xScale + xo;
-                int j4 = (int)d14;
-                if(d14 < (double)j4)
-                {
-                    j4--;
-                }
-                int k4 = j4 & 0xff;
-                d14 -= j4;
-                double d17 = d14 * d14 * d14 * (d14 * (d14 * 6D - 15D) + 10D);
-                for(int l4 = 0; l4 < ySize; l4++)
-                {
-                    double d19 = (y + (double)l4) * yScale + zo;
-                    int j5 = (int)d19;
-                    if(d19 < (double)j5)
-                    {
-                        j5--;
-                    }
-                    int l5 = j5 & 0xff;
-                    d19 -= j5;
-                    double d21 = d19 * d19 * d19 * (d19 * (d19 * 6D - 15D) + 10D);
-                    int l = p[k4] + 0;
-                    int j1 = p[l] + l5;
-                    int k1 = p[k4 + 1] + 0;
-                    int l1 = p[k1] + l5;
-                    double d9 = lerp(d17, grad(p[j1], d14, d19), grad(p[l1], d14 - 1.0D, 0.0D, d19));
-                    double d11 = lerp(d17, grad(p[j1 + 1], d14, 0.0D, d19 - 1.0D), grad(p[l1 + 1], d14 - 1.0D, 0.0D, d19 - 1.0D));
-                    double d23 = lerp(d21, d9, d11);
-                    densityArray[j3++] += d23 * d12;
-                }
+        if (ySize == 1 && this.legacyNoiseType.handleEdgeCaseY) {
+            int i = 0;
+            for (int xi = 0; xi < xSize; xi++) {
+                double xx = (x + xi) * xScale + this.xo;
 
-            }
+                // Find X coordinate of unit square that contains point
+                final int X = (int) Math.floor(xx) & 255;
 
-            return;
-        }
-        int i1 = 0;
-        double d7 = 1.0D / levelScale;
-        int i2 = -1;
-        double d13 = 0.0D;
-        double d15 = 0.0D;
-        double d16 = 0.0D;
-        double d18 = 0.0D;
-        for(int i5 = 0; i5 < xSize; i5++)
-        {
-            double d20 = (x + (double)i5) * xScale + xo;
-            int k5 = (int)d20;
-            if(d20 < (double)k5)
-            {
-                k5--;
+                // Find relative X of point in square
+                xx -= Math.floor(xx);
+
+                // Compute fade curve for X
+                final double u = this.fade(xx);
+
+                for (int zi = 0; zi < zSize; zi++) {
+                    double zz = (z + zi) * zScale + this.zo;
+
+                    // Find Z coordinate of unit square that contains point
+                    final int Z = (int) Math.floor(zz) & 255;
+
+                    // Find relative Z of point in square
+                    zz -= Math.floor(zz);
+
+                    // Compute fade curve for Z
+                    final double w = this.fade(zz);
+
+                    // Hash coordinates of the 4 square corners
+                    final int A =  this.p[X    ];
+                    final int AA = this.p[A    ] + Z;
+                    final int B =  this.p[X + 1];
+                    final int BA = this.p[B    ] + Z;
+
+                    // Add blended results from 4 corners of the square
+                    final double value = this.lerp(
+                        w,
+                        this.lerp(
+                            u,
+                            this.grad2(this.p[AA], xx, zz),
+                            this.grad(this.p[BA], xx - 1, 0, zz)
+                        ),
+                        this.lerp(
+                            u,
+                            this.grad(this.p[AA + 1], xx, 0, zz - 1),
+                            this.grad(this.p[BA + 1], xx - 1, 0, zz - 1)
+                        )
+                    );
+
+                    out[i++] += value * scale;
+                }
             }
-            int i6 = k5 & 0xff;
-            d20 -= k5;
-            double d22 = d20 * d20 * d20 * (d20 * (d20 * 6D - 15D) + 10D);
-            for(int j6 = 0; j6 < zSize; j6++)
-            {
-                double d24 = (z + (double)j6) * zScale + zo;
-                int k6 = (int)d24;
-                if(d24 < (double)k6)
-                {
-                    k6--;
+        } else if (zSize == 1 && this.legacyNoiseType.handleEdgeCaseZ) {
+            int i = 0;
+            for (int xi = 0; xi < xSize; xi++) {
+                double xx = (x + xi) * xScale + this.xo;
+
+                // Find X coordinate of unit square that contains point
+                final int X = (int) Math.floor(xx) & 255;
+
+                // Find relative X of point in square
+                xx -= Math.floor(xx);
+
+                // Compute fade curve for X
+                final double u = this.fade(xx);
+
+                for (int yi = 0; yi < ySize; yi++) {
+                    double yy = (y + yi) * yScale + this.zo;
+
+                    // Find Y coordinate of unit square that contains point
+                    final int Y = (int) Math.floor(yy) & 255;
+
+                    // Find relative Y of point in cube
+                    yy -= Math.floor(yy);
+
+                    // Compute fade curve for Y
+                    final double v = this.fade(yy);
+
+                    // Hash coordinates of the 4 square corners
+                    final int A =  this.p[X    ];
+                    final int AA = this.p[A    ] + Y;
+                    final int B =  this.p[X + 1];
+                    final int BA = this.p[B    ] + Y;
+
+                    // Add blended results from 4 corners of the square
+                    final double value = this.lerp(
+                        v,
+                        this.lerp(
+                            u,
+                            this.grad2(this.p[AA], xx, yy),
+                            this.grad(this.p[BA], xx - 1, 0, yy)
+                        ),
+                        this.lerp(
+                            u,
+                            this.grad(this.p[AA + 1], xx, 0, yy - 1),
+                            this.grad(this.p[BA + 1], xx - 1, 0, yy - 1)
+                        )
+                    );
+
+                    out[i++] += value * scale;
                 }
-                int l6 = k6 & 0xff;
-                d24 -= k6;
-                double d25 = d24 * d24 * d24 * (d24 * (d24 * 6D - 15D) + 10D);
-                for(int i7 = 0; i7 < ySize; i7++)
-                {
-                    double d26 = (y + (double)i7) * yScale + yo;
-                    int j7 = (int)d26;
-                    if(d26 < (double)j7)
-                    {
-                        j7--;
-                    }
-                    int k7 = j7 & 0xff;
-                    d26 -= j7;
-                    double d27 = d26 * d26 * d26 * (d26 * (d26 * 6D - 15D) + 10D);
-                    if(i7 == 0 || k7 != i2)
-                    {
-                        i2 = k7;
-                        int j2 = p[i6] + k7;
-                        int k2 = p[j2] + l6;
-                        int l2 = p[j2 + 1] + l6;
-                        int i3 = p[i6 + 1] + k7;
-                        int k3 = p[i3] + l6;
-                        int l3 = p[i3 + 1] + l6;
-                        d13 = lerp(d22, grad(p[k2], d20, d26, d24), grad(p[k3], d20 - 1.0D, d26, d24));
-                        d15 = lerp(d22, grad(p[l2], d20, d26 - 1.0D, d24), grad(p[l3], d20 - 1.0D, d26 - 1.0D, d24));
-                        d16 = lerp(d22, grad(p[k2 + 1], d20, d26, d24 - 1.0D), grad(p[k3 + 1], d20 - 1.0D, d26, d24 - 1.0D));
-                        d18 = lerp(d22, grad(p[l2 + 1], d20, d26 - 1.0D, d24 - 1.0D), grad(p[l3 + 1], d20 - 1.0D, d26 - 1.0D, d24 - 1.0D));
+            }
+        } else {
+            double lerpedX = 0.0;
+            double lerpedXNegY = 0.0;
+            double lerpedXNegZ = 0.0;
+            double lerpedXNegYNegZ = 0.0;
+
+            int i = 0;
+            int lastY = -1;
+            for (int xi = 0; xi < xSize; xi++) {
+                double xx = (x + xi) * xScale + this.xo;
+
+                // Find X coordinate of unit cube that contains point
+                final int X = (int) Math.floor(xx) & 255;
+
+                // Find relative X of point in cube
+                xx -= Math.floor(xx);
+
+                // Compute fade curve for X
+                final double u = this.fade(xx);
+
+                for (int zi = 0; zi < zSize; zi++) {
+                    double zz = (z + zi) * zScale + this.zo;
+
+                    // Find Z coordinate of unit cube that contains point
+                    final int Z = (int) Math.floor(zz) & 255;
+
+                    // Find relative Z of point in cube
+                    zz -= Math.floor(zz);
+
+                    // Compute fade curve for Z
+                    final double w = this.fade(zz);
+
+                    for (int yi = 0; yi < ySize; yi++) {
+                        double yy = (y + yi) * yScale + this.yo;
+
+                        // Find Y coordinate of unit cube that contains point
+                        final int Y = (int) Math.floor(yy) & 255;
+
+                        // Find relative Y of point in cube
+                        yy -= Math.floor(yy);
+
+                        // Compute fade curve for Y
+                        final double v = this.fade(yy);
+
+                        // Optimization - don't recalculate for same unit cube Y coordinate
+                        if (yi == 0 || Y != lastY) {
+                            lastY = Y;
+
+                            // Hash coordinates of the 8 cube corners
+                            final int A =  this.p[X    ] + Y;
+                            final int AA = this.p[A    ] + Z;
+                            final int AB = this.p[A + 1] + Z;
+                            final int B =  this.p[X + 1] + Y;
+                            final int BA = this.p[B    ] + Z;
+                            final int BB = this.p[B + 1] + Z;
+
+                            // Add blended results from 8 corners of the cube
+                            lerpedX = this.lerp(
+                                u,
+                                this.grad(this.p[AA], xx, yy, zz),
+                                this.grad(this.p[BA], xx - 1, yy, zz)
+                            );
+                            lerpedXNegY = this.lerp(
+                                u,
+                                this.grad(this.p[AB], xx, yy - 1, zz),
+                                this.grad(this.p[BB], xx - 1, yy - 1, zz)
+                            );
+                            lerpedXNegZ = this.lerp(
+                                u,
+                                this.grad(this.p[AA + 1], xx, yy, zz - 1),
+                                this.grad(this.p[BA + 1], xx - 1, yy, zz - 1)
+                            );
+                            lerpedXNegYNegZ = this.lerp(
+                                u,
+                                this.grad(this.p[AB + 1], xx, yy - 1, zz - 1),
+                                this.grad(this.p[BB + 1], xx - 1, yy - 1, zz - 1)
+                            );
+                        }
+
+                        final double lerpedXY = this.lerp(v, lerpedX, lerpedXNegY);
+                        final double lerpedXYNegZ = this.lerp(v, lerpedXNegZ, lerpedXNegYNegZ);
+                        final double lerpedXYZ = this.lerp(w, lerpedXY, lerpedXYNegZ);
+
+                        out[i++] += lerpedXYZ * scale;
                     }
-                    double d28 = lerp(d27, d13, d15);
-                    double d29 = lerp(d27, d16, d18);
-                    double d30 = lerp(d25, d28, d29);
-                    densityArray[i1++] += d30 * d7;
                 }
-
             }
-
         }
-
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/LegacyNoiseType.java b/game/core/src/main/java/net/minecraft/core/world/noise/LegacyNoiseType.java
new file mode 100644
index 000000000..1d8b330f8
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/LegacyNoiseType.java
@@ -0,0 +1,15 @@
+package net.minecraft.core.world.noise;
+
+public enum LegacyNoiseType {
+    NONE(true, true),
+    ALPHA(false, false),
+    BETA(true, false);
+
+    public final boolean handleEdgeCaseY;
+    public final boolean handleEdgeCaseZ;
+
+    LegacyNoiseType(final boolean handleEdgeCaseY, final boolean handleEdgeCaseZ) {
+        this.handleEdgeCaseY = handleEdgeCaseY;
+        this.handleEdgeCaseZ = handleEdgeCaseZ;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/RetroPerlinNoise.java b/game/core/src/main/java/net/minecraft/core/world/noise/RetroPerlinNoise.java
index 7e1bd7b75..c73f9a104 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/RetroPerlinNoise.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/RetroPerlinNoise.java
@@ -3,7 +3,7 @@ package net.minecraft.core.world.noise;
 import java.util.Random;
 
 public class RetroPerlinNoise
-		extends BasePerlinNoise<RetroImprovedNoise>
+		extends BasePerlinNoise<ImprovedNoise>
 {
 	public RetroPerlinNoise(long seed, int levels)
 	{
@@ -16,13 +16,13 @@ public class RetroPerlinNoise
 	}
 
 	@Override
-	protected RetroImprovedNoise[] newOctaves(Random random, int numOctaves)
+	protected ImprovedNoise[] newOctaves(Random random, int numOctaves)
 	{
-		RetroImprovedNoise[] levels = new RetroImprovedNoise[numOctaves];
+		ImprovedNoise[] levels = new ImprovedNoise[numOctaves];
 
 		for (int i = 0; i < numOctaves; i++)
 		{
-			levels[i] = new RetroImprovedNoise(random);
+			levels[i] = new ImprovedNoise(random, LegacyNoiseType.ALPHA);
 		}
 
 		return levels;
